version: '3.8'

services:
  redis:
    image: redis
    restart: always
    ports:
      - "6379:6379"


  db:
    image: postgres:12.8
    volumes:
      - postgres_data:/var/lib/postgresql/data/
    depends_on:
      - redis
    env_file:
      - ./.env



  web:
    build: .
    restart: always
    ports:
      - "8000:8000"
    volumes:
      - static_value:/code/static/
      - media_value:/code/media/
    depends_on:
      - db
    env_file:
      - ./.env



  nginx:
    image: nginx:1.19.3
    ports:
      - "80:80"

    volumes:
      - ./nginx/default.conf:/etc/nginx/conf.d/default.conf
      - static_value:/var/html/static/
      - media_value:/var/html/media/

    depends_on:
      - web


  celery-worker:
    build: .
    container_name: celery-worker
    command: [ 'celery', '--workdir=./', '-A', 'employeeCore', 'worker' ]
    volumes:
      - .:/celery
    links:
      - redis
    depends_on:
      - db
      - redis
    env_file:
      - ./.env


  celery-beat:
    build: .
    container_name: celery-beat
    command: [ 'celery', '--workdir=./', '-A', 'employeeCore', 'beat' ]
    volumes:
      - .:/celery
    links:
      - celery-worker
      - redis
    depends_on:
      - celery-worker
      - redis
    env_file:
      - ./.env


  flower:
    image: mher/flower
    container_name: flower
    environment:
      - CELERY_BROKER_URL=redis://redis:6379
      - FLOWER_PORT=8888
    ports:
      - 8888:8888
    links:
      - redis
      - celery-worker
      - celery-beat
    depends_on:
      - redis
      - celery-worker
      - celery-beat
    env_file:
      - ./.env


volumes:
  postgres_data:
  static_value:
  media_value:
